LeetCode: Intersection of Two Linked Lists 解题报告

Intersection of Two Linked Lists

Write a program to find the node at which the intersection of two singly linked lists begins.


For example, the following two linked lists:

A:          a1 → a2
                   ↘
                     c1 → c2 → c3
                   ↗            
B:     b1 → b2 → b3
begin to intersect at node c1.


Notes:

If the two linked lists have no intersection at all, return null.
The linked lists must retain their original structure after the function returns.
You may assume there are no cycles anywhere in the entire linked structure.
Your code should preferably run in O(n) time and use only O(1) memory.
Credits:
Special thanks to @stellari for adding this problem and creating all test cases.

SOLUTION 1:

1. 得到2个链条的长度。

2. 将长的链条向前移动差值(len1 - len2)

3. 两个指针一起前进,遇到相同的即是交点,如果没找到,返回null.

相当直观的解法。空间复杂度O(1), 时间复杂度O(m+n)

 1 public ListNode getIntersectionNode1(ListNode headA, ListNode headB) {
 2         if (headA == null || headB == null) {
 3             return null;
 4         }
 5         
 6         int lenA = getLen(headA);
 7         int lenB = getLen(headB);
 8         
 9         if (lenA > lenB) {
10             while (lenA > lenB) {
11                 headA = headA.next;
12                 lenA--;
13             }
14         } else {
15             while (lenA < lenB) {
16                 headB = headB.next;
17                 lenB--;
18             }
19         }
20         
21         while (headA != null) {
22             if (headA == headB) {
23                 return headA;
24             }
25             headA = headA.next;
26             headB = headB.next;
27         }
28         
29         return null;
30     }
31     
32     public int getLen(ListNode node) {
33         int len = 0;
34         while (node != null) {
35             len++;
36             node = node.next;
37         }
38         return len;
39     }
View Code

 2014.12.17 redo:

 1 /**
 2  * Definition for singly-linked list.
 3  * public class ListNode {
 4  *     int val;
 5  *     ListNode next;
 6  *     ListNode(int x) {
 7  *         val = x;
 8  *         next = null;
 9  *     }
10  * }
11  */
12 public class Solution {
13     public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
14         if (headA == null || headB == null) {
15             return null;
16         }
17         
18         ListNode cur = headA;
19         int len1 = getLen(headA);
20         int len2 = getLen(headB);
21         
22         int cnt = Math.abs(len1 - len2);
23         
24         // cut the longer list.
25         if (len1 > len2) {
26             while (cnt > 0) {
27                 headA = headA.next;
28                 cnt--;
29             }
30         } else {
31             while (cnt > 0) {
32                 headB = headB.next;
33                 cnt--;
34             }
35         }
36             
37         while (headA != null) {
38             if (headA == headB) {
39                 return headA;
40             }
41             
42             headA = headA.next;
43             headB = headB.next;
44         }
45         
46         return null;
47     }
48     
49     public int getLen(ListNode head) {
50         int cnt = 0;
51         while (head != null) {
52             head = head.next;
53             cnt++;
54         }
55         
56         return cnt;
57     }
58 }
View Code

SOLUTION 2:

解完后,打开Leetcode的solution, 找到一个很巧妙的解法。其实与解法1相比应该快不了多少,但是写出来超有B格的。。

Two pointer solution (O(n+m) running time, O(1) memory):
Maintain two pointers pA and pB initialized at the head of A and B, respectively. Then let them both traverse through the lists, one node at a time.
When pA reaches the end of a list, then redirect it to the head of B (yes, B, that's right.); similarly when pB reaches the end of a list, redirect it the head of A.
If at any point pA meets pB, then pA/pB is the intersection node.
To see why the above trick would work, consider the following two lists: A = {1,3,5,7,9,11} and B = {2,4,9,11}, which are intersected at node '9'. Since B.length (=4) < A.length (=6), pB would reach the end of the merged list first, because pB traverses exactly 2 nodes less than pA does. By redirecting pB to head A, and pA to head B, we now ask pB to travel exactly 2 more nodes than pA would. So in the second iteration, they are guaranteed to reach the intersection node at the same time.
If two lists have intersection, then their last nodes must be the same one. So when pA/pB reaches the end of a list, record the last element of A/B respectively. If the two last elements are not the same one, then the two lists have no intersections.

主页君实现如下:

 1 public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
 2         if (headA == null || headB == null) {
 3             return null;
 4         }
 5         
 6         ListNode pA = headA;
 7         ListNode pB = headB;
 8         
 9         ListNode tailA = null;
10         ListNode tailB = null;
11         
12         while (true) {
13             if (pA == null) {
14                 pA = headB;
15             }
16             
17             if (pB == null) {
18                 pB = headA;
19             }
20             
21             if (pA.next == null) {
22                 tailA = pA;
23             }
24             
25             if (pB.next == null) {
26                 tailB = pB;
27             }
28             
29             //The two links have different tails. So just return null;
30             if (tailA != null && tailB != null && tailA != tailB) {
31                 return null;
32             }
33             
34             if (pA == pB) {
35                 return pA;
36             }
37             
38             pA = pA.next;
39             pB = pB.next;
40         }
41     }
View Code

GITHUB:

https://github.com/yuzhangcmu/LeetCode_algorithm/blob/master/list/GetIntersectionNode1.java

附一个链表大总结的链接:

http://weibo.com/3948019741/BseJ6ukI3

原文地址:https://www.cnblogs.com/yuzhangcmu/p/4128794.html